## astroidmail 0.13

=== CMakeLists.txt ===
##
# This MUST be the first line
#
cmake_minimum_required (VERSION 3.9)

##
# project name
#
project (astroid)

##
# don't use obscure build types, but only Debug and Release
#
set (CMAKE_CONFIGURATION_TYPES Debug Release CACHE TYPE INTERNAL FORCE)
message (STATUS "Available config types: ${CMAKE_CONFIGURATION_TYPES}")

##
# generate a compile_commands.json file (needed for ninja)
#
set (CMAKE_EXPORT_COMPILE_COMMANDS ON)

##
# make sure the user deliberately selects a  build type
#
if (NOT CMAKE_BUILD_TYPE)
    message ( WARNING "No CMAKE_BUILD_TYPE value specified, defaulting to Debug." )
    set (CMAKE_BUILD_TYPE "Debug" CACHE STRING "Choose the type of build." FORCE)
else ()
    message ( STATUS "The CMake build type is: ${CMAKE_BUILD_TYPE}" )
endif ()

##
# where supporting modules live
#
set (CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

##
# version number
#
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  # debug build - retrieve current project version from git
  execute_process (
    COMMAND git describe --abbrev=8 --tags --always
    OUTPUT_VARIABLE PROJECT_VERSION
    OUTPUT_STRIP_TRAILING_WHITESPACE
    )
else ()
  # release build - use hard-coded version string
  set ( PROJECT_VERSION "0.13.0" )
endif ()

##
# plugin API namespace and version
#
if(NOT DISABLE_PLUGINS)
  set (PLUGIN_NAMESPACE    "Astroid")
  set (PLUGIN_API_VERSION  "0.2")
endif()

##
# cmake -D...=ON|OFF command line feature switches and their default values
#
option (DISABLE_TERMINAL         "Disable embedded terminal (default = enabled)"  OFF)
option (DISABLE_EMBEDDED_EDITOR  "Disable embedded editor (default = enabled)"    OFF)
option (DISABLE_PLUGINS          "Disable plugins (default = enabled)"            OFF)
option (ENABLE_PROFILING         "Enable profiling (default = disabled)"          OFF)
option (DISABLE_LIBSASS          "Disable libsass, requires a sassc compiler (default = enabled)" OFF)
option (DEBUG_WEBKIT             "Turn on extra debug options for WebKit (default = disabled)"    OFF)

set (SCSS_COMPILER "sassc" CACHE STRING "SCSS compiler to use when libsass is disabled (default = sassc)")

##
# welcome message
#
message (STATUS "Building ${PROJECT_NAME} ${PROJECT_VERSION}")

##
# check for required packages and libraries
#
find_package( Notmuch REQUIRED )
if (Notmuch_INDEX_FILE_API)
  add_definitions ( -DHAVE_NOTMUCH_INDEX_FILE )
endif()

find_package ( PkgConfig REQUIRED )
pkg_check_modules (GTKMM3     REQUIRED  gtkmm-3.0>=3.10)
pkg_check_modules (GLIBMM2    REQUIRED  glibmm-2.4)
pkg_check_modules (WEBKIT2GTK REQUIRED  webkit2gtk-4.0)
pkg_check_modules (SASS       REQUIRED  libsass)
pkg_check_modules (GIOMM2     REQUIRED  giomm-2.4)
pkg_check_modules (GIOUNIX    REQUIRED  gio-unix-2.0)

string (REGEX REPLACE "([0-9]+\.[0-9]+)\.[0-9]+" "\\1" GMIME_MAJOR_MINOR ${Notmuch_GMIME_VERSION})
pkg_check_modules (GMIME      REQUIRED  gmime-${GMIME_MAJOR_MINOR}>=${Notmuch_GMIME_VERSION})

find_package ( Threads )

find_package ( Boost REQUIRED
  COMPONENTS
  filesystem
  program_options
  log_setup
  log
  thread
  date_time
  system
  )

find_package (Protobuf 3.0 REQUIRED)
set (PROTO_FILES
  src/modes/thread_view/webextension/messages.proto
  )

PROTOBUF_GENERATE_CPP (PROTO_SRC PROTO_HDR ${PROTO_FILES})


if(APPLE)
  # with homebrew, libgettext is keg-only, i.e. not symlinked into
  # /usr/local, and it does not provide any pkg-config information of
  # its own; hence we have to locate it manually
  set ( Gettext_LDFLAGS "-L/usr/local/opt/gettext/lib" )
endif(APPLE)

pkg_check_modules (VTE2 vte-2.91)
if(DISABLE_TERMINAL OR ( NOT VTE2_FOUND ))
  add_definitions ( -DDISABLE_VTE )
  if(NOT VTE2_FOUND)
    message (WARNING "Vte library not found.")
  endif()
  message (STATUS "Disabling embedded terminal.")
endif()

##
# compile flags and options
#

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")

include_directories (
  ${GTKMM3_INCLUDE_DIRS}
  ${GLIBMM2_INCLUDE_DIRS}
  ${GIOMM2_INCLUDE_DIRS}
  ${GIOUNIX_INCLUDE_DIRS}
  ${GMIME_INCLUDE_DIRS}
  ${WEBKIT2GTK_INCLUDE_DIRS}
  ${VTE2_INCLUDE_DIRS}
  ${SASS_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIRS}
  ${PROTOBUF_INCLUDE_DIRS}
  )

add_compile_options (
  ${GTKMM3_CFLAGS}
  ${GLIBMM2_CFLAGS}
  ${GIOMM2_CFLAGS}
  ${GIOUNIX_CFLAGS}
  ${GMIME_CFLAGS}
  ${WEBKIT2GTK_CFLAGS}
  ${VTE2_CFLAGS}
  ${SASS_CFLAGS}
  )

#
# default options
#
add_compile_options (
  -Wall
  )
add_definitions (
  -DBOOST_LOG_DYN_LINK
  -DBOOST_LOG_USE_NATIVE_SYSLOG
  )
#
# debug builds
#
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
add_compile_options (
  -Wextra
  -g
  )
add_definitions (
  -DDEBUG
  )
endif ()
#
# release builds
#
if (CMAKE_BUILD_TYPE STREQUAL "Release")
add_compile_options (
  -O2
  )
endif()

if (ENABLE_PROFILING)
  message (STATUS "Enabling profiling.")
  add_compile_options ( -pg )
  set (CMAKE_EXE_LINKER_FLAGS "-pg")
endif()

set ( GIT_DESC ${PROJECT_VERSION} )
set ( PREFIX ${CMAKE_INSTALL_PREFIX} )
configure_file (
    src/build_config.hh.in
    src/build_config.hh
    )

include (CheckIncludeFile)
if(NOT DISABLE_LIBSASS)
  set ( CMAKE_REQUIRED_INCLUDES ${SASS_INCLUDE_DIRS} )
  check_include_file (sass_context.h SASSCTX_SASS_CONTEXT_H)
  check_include_file (sass/context.h SASSCTX_CONTEXT_H)
  if( SASSCTX_SASS_CONTEXT_H )
    add_definitions ( -DSASSCTX_SASS_CONTEXT_H )
  elseif( SASSCTX_CONTEXT_H )
    add_definitions ( -DSASSCTX_CONTEXT_H )
  else()
    message (
      FATAL_ERROR
      "libsass must be installed: could not find header file. You can disable libsass with -DDISABLE_LIBSASS=ON, however, that requires a SCSS compiler like 'sassc' which can be specified with -DSCSS_COMPILER=<path to compiler>."
      )
  endif()
else ()
  add_definitions ( -DDISABLE_LIBSASS )
  # the css target is defined after astroid target has been defined
endif()

include_directories (
  src/
  src/actions
  src/modes
  src/modes/editor
  src/modes/thread_index
  src/modes/thread_view
  src/modes/thread_view/webextension
  src/plugin
  src/utils
  src/utils/gmime
  ${CMAKE_BINARY_DIR}/src	# needed to find the generated build_config.hh
  ${CMAKE_BINARY_DIR}	    # needed to find protobuf files
  )

add_library(
  hypocycloid

  src/account_manager.cc
  src/astroid.cc
  src/chunk.cc
  src/command_bar.cc
  src/compose_message.cc
  src/config.cc
  src/crypto.cc
  src/db.cc
  src/main_window.cc
  src/message_thread.cc
  src/poll.cc

  src/modes/edit_message.cc
  src/modes/forward_message.cc
  src/modes/help_mode.cc
  src/modes/keybindings.cc
  src/modes/log_view.cc
  src/modes/mode.cc
  src/modes/paned_mode.cc
  src/modes/raw_message.cc
  src/modes/reply_message.cc
  src/modes/saved_searches.cc

  src/modes/editor/external.cc

  src/modes/thread_index/query_loader.cc
  src/modes/thread_index/thread_index.cc
  src/modes/thread_index/thread_index_list_cell_renderer.cc
  src/modes/thread_index/thread_index_list_view.cc

  src/modes/thread_view/theme.cc
  src/modes/thread_view/thread_view.cc
  src/modes/thread_view/page_client.cc
  src/modes/thread_view/webextension/ae_protocol.cc
  src/modes/thread_view/webextension/dom_utils.cc

  src/actions/action.cc
  src/actions/action_manager.cc
  src/actions/cmdaction.cc
  src/actions/difftag_action.cc
  src/actions/onmessage.cc
  src/actions/tag_action.cc
  src/actions/toggle_action.cc

  src/utils/address.cc
  src/utils/cmd.cc
  src/utils/date_utils.cc
  src/utils/gravatar.cc
  src/utils/resource.cc
  src/utils/ustring_utils.cc
  src/utils/utils.cc
  src/utils/vector_utils.cc

  src/utils/gmime/gmime-compat.cc
  src/utils/gmime/gmime-filter-html-bq.c
  src/utils/gmime/gtrie.c
  src/utils/gmime/url-scanner.c

  ${PROTO_SRC}
  ${PROTO_HDR}
  ${PROTO_FILES}
  )

add_executable (
  astroid

  src/main.cc
  )

target_link_libraries (
  astroid

  hypocycloid
  ${Notmuch_LIBRARIES}
  ${WEBKIT2GTK_LDFLAGS}
  ${GTKMM3_LDFLAGS}
  ${GLIBMM2_LDFLAGS}
  ${GIOMM2_LDFLAGS}
  ${GIOUINX_LDFLAGS}
  ${GMIME_LDFLAGS}
  ${VTE2_LDFLAGS}
  ${SASS_LDFLAGS}
  ${Boost_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
  ${Gettext_LDFLAGS}
  ${PROTOBUF_LIBRARIES}
  )

## Build Web Extension
add_library (
  tvextension SHARED

  src/modes/thread_view/webextension/tvextension.cc
  src/modes/thread_view/webextension/ae_protocol.cc
  src/modes/thread_view/webextension/dom_utils.cc
  src/utils/ustring_utils.cc
  ${PROTO_SRC}
  ${PROTO_HDR}
  ${PROTO_FILES}
  )

target_link_libraries (
  tvextension

  ${WEBKIT2GTK_LDFLAGS}
  ${GLIBMM2_LDFLAGS}
  ${GIOMM2_LDFLAGS}
  ${GIOUINX_LDFLAGS}
  ${CMAKE_THREAD_LIBS_INIT}
  ${PROTOBUF_LIBRARIES}
  ${GTKMM3_LDFLAGS}
  ${Boost_LIBRARIES}
  )

target_compile_definitions (
  tvextension PUBLIC

  ASTROID_WEBEXTENSION
  )

add_dependencies (astroid tvextension)

# Xcode needs to be explicitly told about the header files in order to
# show them in the project and automatically display them in the
# assitant editor
if(CMAKE_GENERATOR STREQUAL "Xcode")
  message(STATUS "Xcode build: adding headers to project")
  file(GLOB_RECURSE my_header_files src/ "*.h" "*.hh")
  target_sources(hypocycloid PRIVATE ${my_header_files})
endif()

##
# conditional compilation based on feature switches
#
if(DEBUG_WEBKIT)
  add_definitions ( -DDEBUG_WEBKIT )
  message (STATUS "Enabling debug WebKit.")
endif()

##
# pre-compiled style sheets (instead of dynamic at run-time)
#
if(DISABLE_LIBSASS)
  message (STATUS "Generating thread-view.css")
  add_custom_command ( TARGET astroid
    COMMAND ${SCSS_COMPILER} ${CMAKE_SOURCE_DIR}/ui/thread-view.scss ${CMAKE_BINARY_DIR}/thread-view.css )
  add_custom_command ( TARGET astroid
    COMMAND ${SCSS_COMPILER} ${CMAKE_SOURCE_DIR}/ui/part.scss ${CMAKE_BINARY_DIR}/part.css )
endif()

##
# embedded editor
#
if(DISABLE_EMBEDDED_EDITOR)
  add_definitions ( -DDISABLE_EMBEDDED )
  message (STATUS "Disabling embedded editor.")
else(DISABLE_EMBEDDED_EDITOR)
  if (APPLE)
    message (WARNING "Embedded editor cannot be built on macOS; disabling embedded editor.")
    add_definitions ( -DDISABLE_EMBEDDED )
  else(APPLE)
    target_sources (
      hypocycloid
      PRIVATE
      src/modes/editor/editor.cc
      src/modes/editor/plugin.cc
      )
  endif(APPLE)
endif(DISABLE_EMBEDDED_EDITOR)

##
# plugins
#
if(DISABLE_PLUGINS)
  add_definitions ( -DDISABLE_PLUGINS )
  message (STATUS "Disabling plugins.")
else()
  if(APPLE)
    # with homebrew, libffi is keg-only, i.e. not symlinked into
    # /usr/local; hence we have to tell pkg-config where to look for
    # it
    list ( APPEND CMAKE_PREFIX_PATH /usr/local/opt/libffi )
  endif()
  include (FindGObjectIntrospection)   # this performs a pkg_check_modules()
  pkg_check_modules (PEAS libpeas-1.0>=1.0.0)
  if(INTROSPECTION_FOUND AND PEAS_FOUND)
    #
    # GObject introspection
    #
    include (GObjectIntrospectionMacros)
    set (GIR_NAME "${PLUGIN_NAMESPACE}-${PLUGIN_API_VERSION}.gir")
    set (${GIR_NAME}_NAMESPACE      ${PLUGIN_NAMESPACE})
    set (${GIR_NAME}_VERSION        ${PLUGIN_API_VERSION})
    set (${GIR_NAME}_INCLUDEPKGS    GObject-2.0 GMime-${GMIME_MAJOR_MINOR})
    set (${GIR_NAME}_PROGRAM        ${CMAKE_CURRENT_BINARY_DIR}/gir_main)
    set (${GIR_NAME}_FILES
      src/plugin/astroid_activatable.c
      src/plugin/thread_view_activatable.c
      src/plugin/thread_index_activatable.c
      src/plugin/astroid_activatable.h
      src/plugin/thread_view_activatable.h
      src/plugin/thread_index_activatable.h
      src/plugin/gir_main.c
      )
    list ( APPEND INTROSPECTION_GIRS ${GIR_NAME} )
    set (INTROSPECTION_SCANNER_ARGS --warn-all)
    gir_add_introspections (INTROSPECTION_GIRS)   # magic happens here
    #
    # additional source files for astroid (plugin framework)
    #
    target_sources (
      hypocycloid
      PRIVATE
      src/plugin/astroid_activatable.c
      src/plugin/manager.cc
      src/plugin/thread_index_activatable.c
      src/plugin/thread_view_activatable.c
      )
    #
    # link astroid against libpeas
    #
    include_directories ( ${PEAS_INCLUDE_DIRS} )
    target_link_libraries (
      astroid
      ${PEAS_LDFLAGS}
      )
    #

=== debian/changelog ===
astroidmail (0.13-3) unstable; urgency=medium

  * Fix avoid running testsuite in parallel.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 25 Aug 2018 13:13:10 +0200

astroidmail (0.13-2) experimental; urgency=medium

  * Update package relations:
    + Fix build-depend on and recommend node-marked.
    + Fix build-depend on recent gnupg.
  * Refresh patches with shortening quilt options.
  * Cherry-pick patch from upstream git:
    + Bump testsuite plugins to GIR v0.2.

  Thanks to upstream for clues on above
  (see https://github.com/astroidmail/astroid/issues/540 ).

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 25 Aug 2018 12:06:12 +0200

astroidmail (0.13-1) experimental; urgency=medium

  [ upstream ]
  * New release.

  [ Jonas Smedegaard ]
  * Update copyright info: Add cmake files.
  * Update package relations:
    + Build-depend on libwebkit2gtk-4.0-dev (not libwebkitgtk-3.0-dev).
    + Build-depend on protobuf-compiler and recent libprotobuf-dev.
    + Build-depend on cmake (not meson).
  * Cherry-pick patches from upstream git:
    + Close correct tab if Mode::close is called on non-active tab.
    + cmake: libhypocycloid should always be static.
    + cmake: fix scalable icon install path.
  * Update build cleanup.
  * Update Vcs-* fields: Packaging moved to Salsa.

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 24 Aug 2018 13:52:47 +0200

astroidmail (0.10.2-2) unstable; urgency=medium

  * Fix create fake $HOME for testsuite to please gnupg2.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 11 Oct 2017 19:57:04 +0200

astroidmail (0.10.2-1) unstable; urgency=medium

  [ upstream ]
  * New release.

  [ Jonas Smedegaard ]
  * Drop patch 2001: Obsoleted by switch to meson build system.
  * Stop resolve package relations in rules file.
  * Stop build-depend on dh-buildinfo.
  * Sort package relations.
  * Declare docs and examples in debhelper files (not rules file).
  * Use meson and short-form dh (not scons or cdbs).
    Build-depend on meson (not cdbs).
  * Use help2man and xvfb to generate manpage.
    Build-depend on help2man.
  * Fix set LC_ALL (not LOCALE) in environment during testsuite.
  * Use semantic newlines in copyright and license texts.
    Reword comments in copyright file.
  * Use https protocol in homepage URL.
  * Declare compliance with Debian Policy 4.1.1.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 11 Oct 2017 19:05:23 +0200

astroidmail (0.10-1) experimental; urgency=medium

  [ upstream ]
  * New release.

  [ Jonas Smedegaard ]
  * Install upstream changelog.
  * Apply patch 2001 to fix revert to not use _index_file over
    _add_message: A commit close to release causing FTBFS, and confirmed
    upstream to not cause harm to avoid.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 23 Sep 2017 10:28:24 +0200

astroidmail (0.9.1+20170919-1) experimental; urgency=medium

  [ upstream ]
  * Development snapshot.

  [ Jonas Smedegaard ]
  * Update watch file: Use substitution strings.
  * Update copyright info: Use https protocol in file format URL.
  * Tighten lintian overrides regarding License-Reference.
  * Update package relations: Build-depend on libgmime-3.0-dev (not
    libgmime-2.6-dev).

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 19 Sep 2017 20:44:32 +0200

astroidmail (0.9.1-1) experimental; urgency=low

  [ Jonas Smedegaard ]
  * Initial release.
    Closes: bug#873202.

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 27 Aug 2017 14:03:44 +0200

=== debian/control ===
Source: astroidmail
Section: mail
Priority: optional
Maintainer: Jonas Smedegaard <dr@jones.dk>
Build-Depends:
 cmake,
 debhelper,
 help2man,
 gnupg (>= 2),
 libboost-date-time-dev,
 libboost-filesystem-dev,
 libboost-log-dev,
 libboost-program-options-dev,
 libboost-system-dev,
 libboost-test-dev,
 libboost-thread-dev,
 libgirepository1.0-dev,
 libglibmm-2.4-dev,
 libgmime-3.0-dev,
 libgtkmm-3.0-dev,
 libnotmuch-dev,
 libpeas-dev,
 libprotobuf-dev (>= 3),
 libsass-dev,
 libvte-2.91-dev,
 libwebkit2gtk-4.0-dev,
 node-marked,
 notmuch,
 pkg-config,
 protobuf-compiler,
 python3-gi,
 xauth,
 xvfb,
Standards-Version: 4.1.1
Homepage: https://astroidmail.github.io/
Vcs-Browser: https://salsa.debian.org/debian/astroidmail
Vcs-Git: https://salsa.debian.org/debian/astroidmail.git

Package: astroid
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 gnupg (>= 2),
 node-marked,
 vim-gtk3 | emacs25,
 xdg-utils,
Description: graphical notmuch email client
 Astroid is a lightweight and fast Mail User Agent that provides a
 graphical interface to searching, display and composing email,
 organized in thread and tags. Astorid uses the notmuch backend for
 blazingly fast searches through tons of email. Astroid searches,
 displays and compose emails - and rely on other programs for fetching,
 syncing and sending email.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright 2017 Jonas Smedegaard <dr@jones.dk>
# Description: Main Debian packaging script for Astroid
#
# This program is free software;
# you can redistribute it and/or modify it
# under the terms of the GNU General Public License
# as published by the Free Software Foundation;
# either version 3, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY;
# without even the implied warranty
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.
# If not, see <http://www.gnu.org/licenses/>.

# resolve if release is experimental
include /usr/share/dpkg/pkg-info.mk
EXP_RELEASE = $(filter experimental% UNRELEASED,$(DEB_DISTRIBUTION))

%:
	dh $@ --parallel

override_dh_auto_build:
	dh_auto_build
	xvfb-run -a help2man \
		--name 'graphical notmuch email client' \
		--version-string "astroid $(DEB_VERSION_UPSTREAM_REVISION)" \
		--no-info \
		--output debian/astroid.1 \
		obj-*/astroid

# use virtual X11 and UTF-8 in testsuite
# create fake $HOME to please gnupg2
# ignore testuite failure when targeting experimental
override_dh_auto_test:
	mkdir debian/tmphome
	HOME=debian/tmphome LC_ALL=C.UTF-8 xvfb-run -a \
		dh_auto_test --no-parallel $(if $(EXP_RELEASE), || true)
	rm -rf debian/tmphome

# avoid (seemingly) superfluous files
override_dh_auto_install:
	dh_auto_install
	rm debian/astroid/usr/share/astroid/ui/icons/LICENSE
	rm debian/astroid/usr/share/gir-1.0/Astroid-0.2.gir
	rm debian/astroid/usr/lib/girepository-1.0/Astroid-0.2.typelib

## astroidmail 0.14

=== CMakeLists.txt ===
--- 
+++ 
@@ -46,7 +46,7 @@
     )
 else ()
   # release build - use hard-coded version string
-  set ( PROJECT_VERSION "0.13.0" )
+  set ( PROJECT_VERSION "0.14.0" )
 endif ()
 
 ##
@@ -60,10 +60,11 @@
 ##
 # cmake -D...=ON|OFF command line feature switches and their default values
 #
-option (DISABLE_TERMINAL         "Disable embedded terminal (default = enabled)"  OFF)
-option (DISABLE_EMBEDDED_EDITOR  "Disable embedded editor (default = enabled)"    OFF)
-option (DISABLE_PLUGINS          "Disable plugins (default = enabled)"            OFF)
-option (ENABLE_PROFILING         "Enable profiling (default = disabled)"          OFF)
+option (DISABLE_TERMINAL         "Disable embedded terminal (default = enabled)"                  OFF)
+option (DISABLE_EMBEDDED_EDITOR  "Disable embedded editor (default = enabled)"                    OFF)
+option (DISABLE_PLUGINS          "Disable plugins (default = enabled)"                            OFF)
+option (DISABLE_DOCS             "Disable generating docs (manpage) (default = enabled)"          OFF)
+option (ENABLE_PROFILING         "Enable profiling (default = disabled)"                          OFF)
 option (DISABLE_LIBSASS          "Disable libsass, requires a sassc compiler (default = enabled)" OFF)
 option (DEBUG_WEBKIT             "Turn on extra debug options for WebKit (default = disabled)"    OFF)
 
@@ -85,7 +86,7 @@
 find_package ( PkgConfig REQUIRED )
 pkg_check_modules (GTKMM3     REQUIRED  gtkmm-3.0>=3.10)
 pkg_check_modules (GLIBMM2    REQUIRED  glibmm-2.4)
-pkg_check_modules (WEBKIT2GTK REQUIRED  webkit2gtk-4.0)
+pkg_check_modules (WEBKIT2GTK REQUIRED  webkit2gtk-4.0>=2.20)
 pkg_check_modules (SASS       REQUIRED  libsass)
 pkg_check_modules (GIOMM2     REQUIRED  giomm-2.4)
 pkg_check_modules (GIOUNIX    REQUIRED  gio-unix-2.0)
@@ -242,6 +243,8 @@
 add_library(
   hypocycloid
 
+  STATIC
+
   src/account_manager.cc
   src/astroid.cc
   src/chunk.cc
@@ -391,6 +394,31 @@
   add_custom_command ( TARGET astroid
     COMMAND ${SCSS_COMPILER} ${CMAKE_SOURCE_DIR}/ui/part.scss ${CMAKE_BINARY_DIR}/part.css )
 endif()
+
+## Build man pages
+if (NOT DISABLE_DOCS)
+  find_program (SCDOC scdoc) # preferred
+  find_program (RONN  ronn)
+
+  if (SCDOC)
+    add_custom_command (
+      TARGET astroid
+      COMMAND ${SCDOC} < ${CMAKE_SOURCE_DIR}/doc/astroid.1.scd | gzip > ${CMAKE_BINARY_DIR}/astroid.1.gz
+      COMMENT "Generating man page (scdoc)")
+  else ()
+    if (RONN)
+      message (WARNING "Falling back to 'ronn' for man page generation.")
+      add_custom_command (
+        TARGET astroid
+        COMMAND ${RONN} -rp ${CMAKE_SOURCE_DIR}/doc/astroid.1.scd | gzip > ${CMAKE_BINARY_DIR}/astroid.1.gz
+        COMMENT "Generating man page (ronn)")
+    else ()
+      message (FATAL_ERROR "Neither 'scdoc' nor 'ronn' installed. One is required for man page generation.")
+    endif()
+  endif()
+else ()
+  message (STATUS "Documentation generation (manpage) disabled.")
+endif ()
 
 ##
 # embedded editor
@@ -436,36 +464,3 @@
     set (${GIR_NAME}_NAMESPACE      ${PLUGIN_NAMESPACE})
     set (${GIR_NAME}_VERSION        ${PLUGIN_API_VERSION})
     set (${GIR_NAME}_INCLUDEPKGS    GObject-2.0 GMime-${GMIME_MAJOR_MINOR})
-    set (${GIR_NAME}_PROGRAM        ${CMAKE_CURRENT_BINARY_DIR}/gir_main)
-    set (${GIR_NAME}_FILES
-      src/plugin/astroid_activatable.c
-      src/plugin/thread_view_activatable.c
-      src/plugin/thread_index_activatable.c
-      src/plugin/astroid_activatable.h
-      src/plugin/thread_view_activatable.h
-      src/plugin/thread_index_activatable.h
-      src/plugin/gir_main.c
-      )
-    list ( APPEND INTROSPECTION_GIRS ${GIR_NAME} )
-    set (INTROSPECTION_SCANNER_ARGS --warn-all)
-    gir_add_introspections (INTROSPECTION_GIRS)   # magic happens here
-    #
-    # additional source files for astroid (plugin framework)
-    #
-    target_sources (
-      hypocycloid
-      PRIVATE
-      src/plugin/astroid_activatable.c
-      src/plugin/manager.cc
-      src/plugin/thread_index_activatable.c
-      src/plugin/thread_view_activatable.c
-      )
-    #
-    # link astroid against libpeas
-    #
-    include_directories ( ${PEAS_INCLUDE_DIRS} )
-    target_link_libraries (
-      astroid
-      ${PEAS_LDFLAGS}
-      )
-    #

=== tests/CMakeLists.txt ===
##
# Tests
find_package ( Boost REQUIRED
  COMPONENTS
  unit_test_framework
  )

get_property (
  ASTROID_LIBRARIES
  TARGET astroid
  PROPERTY LINK_LIBRARIES
  )

function (add_astroid_test name target source)

  add_executable (
    ${target}

    ${source}
    )

  target_link_libraries (
    ${target}

    ${ASTROID_LIBRARIES}
    ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
    )

  add_test (NAME ${name} COMMAND run_test.sh ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR} ${target})

endfunction()

configure_file (run_test.sh run_test.sh COPYONLY)


# Add the tests

add_astroid_test (generic             test_generic             test_generic.cc            )
add_astroid_test (compose             test_composed_message    test_composed_message.cc   )
add_astroid_test (markdown            test_markdown            test_markdown.cc           )
add_astroid_test (non_existant        test_non_existant_file   test_non_existant_file.cc  )
add_astroid_test (open_db             test_open_db             test_open_db.cc            )
add_astroid_test (convert_error       test_convert_error       test_convert_error.cc      )
add_astroid_test (no_newline          test_no_newline_msg      test_no_newline_msg.cc     )
add_astroid_test (mime_message        test_mime_message        test_mime_message.cc       )
add_astroid_test (theme               test_theme               test_theme.cc              )
add_astroid_test (keybindings         test_keybindings         test_keybindings.cc        )
add_astroid_test (bad_content_id      test_bad_content_id      test_bad_content_id.cc     )
add_astroid_test (notmuch             test_notmuch             test_notmuch.cc            )
add_astroid_test (notmuch_standalone  test_notmuch_standalone  test_notmuch_standalone.cc )
add_astroid_test (address             test_address             test_address.cc            )
add_astroid_test (dates               test_dates               test_dates.cc              )
add_astroid_test (crypto              test_crypto              test_crypto.cc             )
add_astroid_test (gmime_version       test_gmime_version       test_gmime_version.cc      )

=== debian/changelog ===
astroidmail (0.14-2.1) unstable; urgency=high

  * Non-maintainer upload.
  * debian/patches: Add a patch to fix compatibility with
    newer ronn and solve the FTBFS. (Closes: #924818)
  * debian/control: Add build-dependency on scdoc in order to
    generate man pages with higher quality.

 -- Boyuan Yang <byang@debian.org>  Thu, 04 Apr 2019 19:03:52 -0400

astroidmail (0.14-2) unstable; urgency=medium

  * Add patch cherry-picked upstream
    to shorten GNUPGHOME length in test.
    Closes: Bug#909190. Thanks to Frédéric Bonnard.
  * Tidy rules: Drop boilerplate.

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 30 Nov 2018 21:54:19 +0100

astroidmail (0.14-1) unstable; urgency=medium

  [ upstream ]
  * New release.

  [ Jonas Smedegaard ]
  * Drop patches cherry-picked upstream and since applied.
  * Stop generate manpage: Provide upstream now.
    Build-depend on ronn.
    Stop build-depend on help2man.

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 01 Oct 2018 10:18:01 +0200

astroidmail (0.13-4) unstable; urgency=medium

  * Add patches cherry-picked upstream:
    + Use cmark (not marked) as default markdown processor.
    + Correctly clear messages and focus state when loading new thread.
    + Do not show default startup queries when intentionally cleared.
  * Set Rules-Requires-Root: no.
  * Declare compliance with Debian Policy 4.2.1.
  * Update package relations: (Build-)depend on cmark (not marked).
  * Update copyright info: Extend coverage for myself.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 26 Sep 2018 08:34:05 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,6 @@
 Build-Depends:
  cmake,
  debhelper,
- help2man,
  gnupg (>= 2),
  libboost-date-time-dev,
  libboost-filesystem-dev,
@@ -24,17 +23,20 @@
  libsass-dev,
  libvte-2.91-dev,
  libwebkit2gtk-4.0-dev,
- node-marked,
+ cmark,
  notmuch,
  pkg-config,
  protobuf-compiler,
  python3-gi,
+ scdoc,
+ ronn,
  xauth,
  xvfb,
-Standards-Version: 4.1.1
+Standards-Version: 4.2.1
 Homepage: https://astroidmail.github.io/
 Vcs-Browser: https://salsa.debian.org/debian/astroidmail
 Vcs-Git: https://salsa.debian.org/debian/astroidmail.git
+Rules-Requires-Root: no
 
 Package: astroid
 Architecture: any
@@ -43,7 +45,7 @@
  ${shlibs:Depends},
 Recommends:
  gnupg (>= 2),
- node-marked,
+ cmark,
  vim-gtk3 | emacs25,
  xdg-utils,
 Description: graphical notmuch email client

=== debian/rules ===
#!/usr/bin/make -f

# resolve if release is experimental
include /usr/share/dpkg/pkg-info.mk
EXP_RELEASE = $(filter experimental% UNRELEASED,$(DEB_DISTRIBUTION))

%:
	dh $@ --parallel

# use virtual X11 and UTF-8 in testsuite
# create fake $HOME to please gnupg2
# ignore testuite failure when targeting experimental
override_dh_auto_test:
	mkdir debian/tmphome
	HOME=debian/tmphome LC_ALL=C.UTF-8 xvfb-run -a \
		dh_auto_test --no-parallel $(if $(EXP_RELEASE), || true)
	rm -rf debian/tmphome

# avoid (seemingly) superfluous files
override_dh_auto_install:
	dh_auto_install
	rm debian/astroid/usr/share/astroid/ui/icons/LICENSE
	rm debian/astroid/usr/share/gir-1.0/Astroid-0.2.gir
	rm debian/astroid/usr/lib/girepository-1.0/Astroid-0.2.typelib

=== debian/watch ===
# run "uscan --report" to check or "gpb import-orig --uscan" to update
version=4
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%,dversionmangle=s/~dfsg\d*$//,repacksuffix=~dfsg" \
 https://github.com/astroidmail/astroid/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## astroidmail 0.15

=== CMakeLists.txt ===
--- 
+++ 
@@ -40,13 +40,13 @@
 if (CMAKE_BUILD_TYPE STREQUAL "Debug")
   # debug build - retrieve current project version from git
   execute_process (
-    COMMAND git describe --abbrev=8 --tags --always
+    COMMAND git -C "${CMAKE_SOURCE_DIR}" describe --abbrev=8 --tags --always
     OUTPUT_VARIABLE PROJECT_VERSION
     OUTPUT_STRIP_TRAILING_WHITESPACE
     )
 else ()
   # release build - use hard-coded version string
-  set ( PROJECT_VERSION "0.14.0" )
+  set ( PROJECT_VERSION "0.15.0" )
 endif ()
 
 ##
@@ -84,12 +84,22 @@
 endif()
 
 find_package ( PkgConfig REQUIRED )
+
+if(APPLE)
+  # with homebrew, libffi is keg-only, i.e. not symlinked into
+  # /usr/local; hence we have to tell pkg-config where to look
+  # for it
+  list ( APPEND CMAKE_PREFIX_PATH /usr/local/opt/libffi )
+  pkg_check_modules (LIBFFI     REQUIRED libffi>=3.0)
+endif()
+
 pkg_check_modules (GTKMM3     REQUIRED  gtkmm-3.0>=3.10)
 pkg_check_modules (GLIBMM2    REQUIRED  glibmm-2.4)
-pkg_check_modules (WEBKIT2GTK REQUIRED  webkit2gtk-4.0>=2.20)
+pkg_check_modules (WEBKIT2GTK REQUIRED  webkit2gtk-4.0>=2.22)
 pkg_check_modules (SASS       REQUIRED  libsass)
 pkg_check_modules (GIOMM2     REQUIRED  giomm-2.4)
 pkg_check_modules (GIOUNIX    REQUIRED  gio-unix-2.0)
+pkg_check_modules (LIBSOUP    REQUIRED  libsoup-2.4)
 
 string (REGEX REPLACE "([0-9]+\.[0-9]+)\.[0-9]+" "\\1" GMIME_MAJOR_MINOR ${Notmuch_GMIME_VERSION})
 pkg_check_modules (GMIME      REQUIRED  gmime-${GMIME_MAJOR_MINOR}>=${Notmuch_GMIME_VERSION})
@@ -142,12 +152,14 @@
   ${GLIBMM2_INCLUDE_DIRS}
   ${GIOMM2_INCLUDE_DIRS}
   ${GIOUNIX_INCLUDE_DIRS}
+  ${LIBSOUP_INCLUDE_DIRS}
   ${GMIME_INCLUDE_DIRS}
   ${WEBKIT2GTK_INCLUDE_DIRS}
   ${VTE2_INCLUDE_DIRS}
   ${SASS_INCLUDE_DIRS}
   ${Boost_INCLUDE_DIRS}
   ${PROTOBUF_INCLUDE_DIRS}
+  ${Notmuch_INCLUDE_DIRS}
   )
 
 add_compile_options (
@@ -155,6 +167,7 @@
   ${GLIBMM2_CFLAGS}
   ${GIOMM2_CFLAGS}
   ${GIOUNIX_CFLAGS}
+  ${LIBSOUP_CFLAGS}
   ${GMIME_CFLAGS}
   ${WEBKIT2GTK_CFLAGS}
   ${VTE2_CFLAGS}
@@ -324,6 +337,7 @@
   ${GLIBMM2_LDFLAGS}
   ${GIOMM2_LDFLAGS}
   ${GIOUINX_LDFLAGS}
+  ${LIBSOUP_LDFLAGS}
   ${GMIME_LDFLAGS}
   ${VTE2_LDFLAGS}
   ${SASS_LDFLAGS}
@@ -410,7 +424,7 @@
       message (WARNING "Falling back to 'ronn' for man page generation.")
       add_custom_command (
         TARGET astroid
-        COMMAND ${RONN} -rp ${CMAKE_SOURCE_DIR}/doc/astroid.1.scd | gzip > ${CMAKE_BINARY_DIR}/astroid.1.gz
+        COMMAND ${RONN} --roff --pipe ${CMAKE_SOURCE_DIR}/doc/astroid.1.scd | gzip > ${CMAKE_BINARY_DIR}/astroid.1.gz
         COMMENT "Generating man page (ronn)")
     else ()
       message (FATAL_ERROR "Neither 'scdoc' nor 'ronn' installed. One is required for man page generation.")
@@ -447,12 +461,6 @@
   add_definitions ( -DDISABLE_PLUGINS )
   message (STATUS "Disabling plugins.")
 else()
-  if(APPLE)
-    # with homebrew, libffi is keg-only, i.e. not symlinked into
-    # /usr/local; hence we have to tell pkg-config where to look for
-    # it
-    list ( APPEND CMAKE_PREFIX_PATH /usr/local/opt/libffi )
-  endif()
   include (FindGObjectIntrospection)   # this performs a pkg_check_modules()
   pkg_check_modules (PEAS libpeas-1.0>=1.0.0)
   if(INTROSPECTION_FOUND AND PEAS_FOUND)
@@ -460,7 +468,3 @@
     # GObject introspection
     #
     include (GObjectIntrospectionMacros)
-    set (GIR_NAME "${PLUGIN_NAMESPACE}-${PLUGIN_API_VERSION}.gir")
-    set (${GIR_NAME}_NAMESPACE      ${PLUGIN_NAMESPACE})
-    set (${GIR_NAME}_VERSION        ${PLUGIN_API_VERSION})
-    set (${GIR_NAME}_INCLUDEPKGS    GObject-2.0 GMime-${GMIME_MAJOR_MINOR})

=== debian/changelog ===
astroidmail (0.15-3.1build1) groovy; urgency=medium

  * Rebuild against new libprotobuf23.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 26 Jul 2020 10:13:29 +0200

astroidmail (0.15-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Patch: Fix FTBFS with gmime >= 3.2.3 (Closes: #952167)

 -- Stefano Rivera <stefanor@debian.org>  Fri, 08 May 2020 18:57:57 -0700

astroidmail (0.15-3) unstable; urgency=medium

  * Add patch 1001 to use command gpg (not gpg2).

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 25 Jul 2019 22:03:35 -0300

astroidmail (0.15-2) unstable; urgency=medium

  * Acknowledge NMU.
    Closes: Bug#924818. Thanks to Boyuan Yang.
  * Drop patch introduced in NMU now applied.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 24 Jul 2019 19:16:18 -0300

astroidmail (0.15-1) unstable; urgency=medium

  [ upstream ]
  * New release.

  [ Jonas Smedegaard ]
  * Update watch file: Fix typo in usage comment.
  * Build-depend on libsoup2.4-dev.
    Tighten to build-depend versioned on libwebkit2gtk-4.0-dev.
    Build-depend on and have astroid recommend w3m.
    Relax to build-depend unversioned on libprotobuf-dev.
    Relax to build-depend on
    and have astroid recommend unversioned gnupg.
  * Declare compliance with Debian Policy 4.4.0.
  * Drop patch cherry-picked upstream now applied.
  * Mark test-only build-dependencies as such.
  * Have astroid recommend and enhance notmuch.
  * Add autopkgtest.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 24 Jul 2019 19:01:24 -0300

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,9 @@
 Maintainer: Jonas Smedegaard <dr@jones.dk>
 Build-Depends:
  cmake,
+ cmark <!nocheck>,
  debhelper,
- gnupg (>= 2),
+ gnupg <!nocheck>,
  libboost-date-time-dev,
  libboost-filesystem-dev,
  libboost-log-dev,
@@ -19,20 +20,21 @@
  libgtkmm-3.0-dev,
  libnotmuch-dev,
  libpeas-dev,
- libprotobuf-dev (>= 3),
+ libprotobuf-dev,
  libsass-dev,
+ libsoup2.4-dev,
  libvte-2.91-dev,
- libwebkit2gtk-4.0-dev,
- cmark,
- notmuch,
+ libwebkit2gtk-4.0-dev (>= 2.22),
+ notmuch <!nocheck>,
  pkg-config,
  protobuf-compiler,
  python3-gi,
  scdoc,
  ronn,
+ w3m <!nocheck>,
  xauth,
  xvfb,
-Standards-Version: 4.2.1
+Standards-Version: 4.4.0
 Homepage: https://astroidmail.github.io/
 Vcs-Browser: https://salsa.debian.org/debian/astroidmail
 Vcs-Git: https://salsa.debian.org/debian/astroidmail.git
@@ -44,10 +46,14 @@
  ${misc:Depends},
  ${shlibs:Depends},
 Recommends:
- gnupg (>= 2),
  cmark,
+ gnupg,
+ notmuch,
  vim-gtk3 | emacs25,
+ w3m,
  xdg-utils,
+Enhances:
+ notmuch,
 Description: graphical notmuch email client
  Astroid is a lightweight and fast Mail User Agent that provides a
  graphical interface to searching, display and composing email,

=== debian/tests/control ===
Test-Command: prove debian/tests/*.t
Depends:
 astroid,
 libtest-command-simple-perl,
 perl,
 xvfb,

=== debian/watch ===
# run "uscan --report" to check or "gbp import-orig --uscan" to update
version=4
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%,dversionmangle=s/~dfsg\d*$//,repacksuffix=~dfsg" \
 https://github.com/astroidmail/astroid/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## astroidmail 0.16

=== CMakeLists.txt ===
--- 
+++ 
@@ -46,7 +46,7 @@
     )
 else ()
   # release build - use hard-coded version string
-  set ( PROJECT_VERSION "0.15.0" )
+  set ( PROJECT_VERSION "0.16.0" )
 endif ()
 
 ##

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -52,3 +52,5 @@
 add_astroid_test (dates               test_dates               test_dates.cc              )
 add_astroid_test (crypto              test_crypto              test_crypto.cc             )
 add_astroid_test (gmime_version       test_gmime_version       test_gmime_version.cc      )
+add_astroid_test (quote_html          test_quote_html          test_quote_html.cc )
+

=== debian/changelog ===
astroidmail (0.16-2) unstable; urgency=medium

  * update copyright info:
    + use Reference field (not License-Reference);
      tighten lintian overrides
    + update coverage

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 09 Nov 2021 03:19:27 +0100

astroidmail (0.16-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * declare compliance with Debian Policy 4.6.0
  * drop patches cherry-picked upstream since applied
  * unfuzz remaining patch

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 18 Aug 2021 22:07:14 +0200

astroidmail (0.15-7) unstable; urgency=medium

  * really fix have autopkgtest tolerate output to stderr

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 25 Jan 2021 16:06:45 +0100

astroidmail (0.15-6) unstable; urgency=medium

  * fix have autopkgtest allow-stderr
  * use debhelper compatibility level 13 (not 12)
  * declare compliance with Debian Policy 4.5.1
  * add patch cherry-picked upstream
    to use std::placeholders everywhere

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 24 Jan 2021 21:16:42 +0100

astroidmail (0.15-5) unstable; urgency=medium

  * fix have autopkgtest depend on xauth
  * annotate superficial autopkgtest
  * declare compliance with Debian Policy 4.5.0
  * simplify source script copyright-check

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 27 Sep 2020 13:20:45 +0200

astroidmail (0.15-4) experimental; urgency=medium

  * fix skip testsuite when DEB_BUILD_OPTIONS contains nocheck
  * update watch file:
    + use substitution strings
    + use dversionmangle=auto
    + simplify regular expressions
    + rewrite usage comment
  * use debhelper compatibility level to 12 (not 9);
    stop explicitly enable parallel build;
    build-depend on debhelper-compat (not debhelper)

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 23 Feb 2020 15:15:06 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends:
  cmake,
  cmark <!nocheck>,
- debhelper,
+ debhelper-compat (= 13),
  gnupg <!nocheck>,
  libboost-date-time-dev,
  libboost-filesystem-dev,
@@ -34,7 +34,7 @@
  w3m <!nocheck>,
  xauth,
  xvfb,
-Standards-Version: 4.4.0
+Standards-Version: 4.6.0
 Homepage: https://astroidmail.github.io/
 Vcs-Browser: https://salsa.debian.org/debian/astroidmail
 Vcs-Git: https://salsa.debian.org/debian/astroidmail.git

=== debian/rules ===
#!/usr/bin/make -f

# resolve if release is experimental
include /usr/share/dpkg/pkg-info.mk
EXP_RELEASE = $(filter experimental% UNRELEASED,$(DEB_DISTRIBUTION))

%:
	dh $@

# use virtual X11 and UTF-8 in testsuite
# ignore testuite failure when targeting experimental
override_dh_auto_test:
	LC_ALL=C.UTF-8 xvfb-run -a \
		dh_auto_test --no-parallel $(if $(EXP_RELEASE), || true)

# avoid (seemingly) superfluous files
execute_after_dh_auto_install:
	rm debian/astroid/usr/share/astroid/ui/icons/LICENSE
	rm debian/astroid/usr/share/gir-1.0/Astroid-0.2.gir
	rm debian/astroid/usr/lib/girepository-1.0/Astroid-0.2.typelib

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

opts=\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-$1/,\
dversionmangle=auto,repacksuffix=~dfsg \
https://github.com/astroidmail/astroid/tags \
.*?@ANY_VERSION@@ARCHIVE_EXT@

## astroidmail 0.16%2B20240629

=== debian/control ===
--- 
+++ 
@@ -22,11 +22,10 @@
  libpeas-dev,
  libprotobuf-dev,
  libsass-dev,
- libsoup2.4-dev,
  libvte-2.91-dev,
- libwebkit2gtk-4.0-dev (>= 2.22),
+ libwebkit2gtk-4.1-dev,
  notmuch <!nocheck>,
- pkg-config,
+ pkgconf,
  protobuf-compiler,
  python3-gi,
  scdoc,
@@ -34,7 +33,7 @@
  w3m <!nocheck>,
  xauth,
  xvfb,
-Standards-Version: 4.6.0
+Standards-Version: 4.7.0
 Homepage: https://astroidmail.github.io/
 Vcs-Browser: https://salsa.debian.org/debian/astroidmail
 Vcs-Git: https://salsa.debian.org/debian/astroidmail.git
@@ -49,7 +48,7 @@
  cmark,
  gnupg,
  notmuch,
- vim-gtk3 | emacs25,
+ sensible-utils,
  w3m,
  xdg-utils,
 Enhances:

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

opts=\
mode=git,pgpmode=none,pretty=0.16+%cd,\
dversionmangle=auto \
https://github.com/astroidmail/astroid.git \
HEAD

## astroidmail 0.16+20240629

=== CMakeLists.txt ===
--- 
+++ 
@@ -95,11 +95,13 @@
 
 pkg_check_modules (GTKMM3     REQUIRED  gtkmm-3.0>=3.10)
 pkg_check_modules (GLIBMM2    REQUIRED  glibmm-2.4)
-pkg_check_modules (WEBKIT2GTK REQUIRED  webkit2gtk-4.0>=2.22)
+pkg_check_modules (WEBKIT2GTK webkit2gtk-4.1)
+if (NOT WEBKIT2GTK_FOUND)
+  pkg_check_modules (WEBKIT2GTK REQUIRED webkit2gtk-4.0>=2.22)
+endif ()
 pkg_check_modules (SASS       REQUIRED  libsass)
 pkg_check_modules (GIOMM2     REQUIRED  giomm-2.4)
-pkg_check_modules (GIOUNIX    REQUIRED  gio-unix-2.0)
-pkg_check_modules (LIBSOUP    REQUIRED  libsoup-2.4)
+pkg_check_modules (GIOUNIX    REQUIRED  gio-unix-2.0>=2.16)
 
 string (REGEX REPLACE "([0-9]+\.[0-9]+)\.[0-9]+" "\\1" GMIME_MAJOR_MINOR ${Notmuch_GMIME_VERSION})
 pkg_check_modules (GMIME      REQUIRED  gmime-${GMIME_MAJOR_MINOR}>=${Notmuch_GMIME_VERSION})
@@ -117,7 +119,9 @@
   system
   )
 
+find_package (Protobuf CONFIG)
 find_package (Protobuf 3.0 REQUIRED)
+set (PROTOBUF_LIBRARIES protobuf::libprotobuf)
 set (PROTO_FILES
   src/modes/thread_view/webextension/messages.proto
   )
@@ -145,14 +149,13 @@
 # compile flags and options
 #
 
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17")
 
 include_directories (
   ${GTKMM3_INCLUDE_DIRS}
   ${GLIBMM2_INCLUDE_DIRS}
   ${GIOMM2_INCLUDE_DIRS}
   ${GIOUNIX_INCLUDE_DIRS}
-  ${LIBSOUP_INCLUDE_DIRS}
   ${GMIME_INCLUDE_DIRS}
   ${WEBKIT2GTK_INCLUDE_DIRS}
   ${VTE2_INCLUDE_DIRS}
@@ -167,7 +170,6 @@
   ${GLIBMM2_CFLAGS}
   ${GIOMM2_CFLAGS}
   ${GIOUNIX_CFLAGS}
-  ${LIBSOUP_CFLAGS}
   ${GMIME_CFLAGS}
   ${WEBKIT2GTK_CFLAGS}
   ${VTE2_CFLAGS}
@@ -336,8 +338,7 @@
   ${GTKMM3_LDFLAGS}
   ${GLIBMM2_LDFLAGS}
   ${GIOMM2_LDFLAGS}
-  ${GIOUINX_LDFLAGS}
-  ${LIBSOUP_LDFLAGS}
+  ${GIOUNIX_LDFLAGS}
   ${GMIME_LDFLAGS}
   ${VTE2_LDFLAGS}
   ${SASS_LDFLAGS}
@@ -366,7 +367,7 @@
   ${WEBKIT2GTK_LDFLAGS}
   ${GLIBMM2_LDFLAGS}
   ${GIOMM2_LDFLAGS}
-  ${GIOUINX_LDFLAGS}
+  ${GIOUNIX_LDFLAGS}
   ${CMAKE_THREAD_LIBS_INIT}
   ${PROTOBUF_LIBRARIES}
   ${GTKMM3_LDFLAGS}
@@ -467,4 +468,3 @@
     #
     # GObject introspection
     #
-    include (GObjectIntrospectionMacros)

=== debian/changelog ===
astroidmail (0.16+20240629-1build2) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:12:55 +0200

astroidmail (0.16+20240629-1build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:02:30 +0200

astroidmail (0.16+20240629-1) unstable; urgency=medium

  [ upstream ]
  * development snapshot;
    highlights:
    + Use symbolic icons
    + Fix gmime assertions being triggered by invalid addresses
    + compose_message:
      to load as byte array, 'file' must be wrapped with copy
    + Add option to disable left icons
    + Add a '#' key to send a message to the trash
    + thread_view: set iframe size in javascript
    + thread_view: set headers and preview via innerText
    + set email preview width in css;
      closes: bug#1036154,
      thanks to Matthias Kirschner and Alberto Garcia
    + stop using deprecated Gtk::HBox
    + default initialize all pointers in Astroid class
    + don't abort when notmuch-config has bad data
    + set both top and bottom margins for prompt bars
    + reduce margins on yes/no revealer to 3
    + improve mailto uri handling
    + use webkit2gtk-4.1 when available and 4.0 as fallback
    + call set_size_request on pane children
    + set minimal pane size to 50
    + wrap line help message for actions on multi-message-selection

  [ Jonas Smedegaard ]
  * update watch file: track git commits (not release tags)
  * unfuzz patch 1001
  * add patch 2001 to use sensible-editor by default;
    recommend sensible-utils
    (not vim-gtk3 or now obsolete emacs25)
  * declare compliance with Debian Policy 4.7.0
  * update copyright info: update coverage
  * build-depend on pkgconf (not pkg-config)
  * update git-buildpackage config:
    + filter-out eventual debian subdir
    + use DEP14 branches
    + add usage config

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 01 Jul 2024 09:05:02 +0200

astroidmail (0.16-2.2) unstable; urgency=medium

  * Non-maintainer upload
  * Drop obsolete Build-Depends: libsoup2.4-dev

 -- Jeremy Bícha <jbicha@ubuntu.com>  Thu, 20 Jun 2024 09:30:34 -0400

astroidmail (0.16-2.1) unstable; urgency=medium

  * Non-maintainer upload
  * Cherry-pick patch to stop using webkit2gtk 4.0 (Closes: #1061526)
  * Update Build-Depends

 -- Jeremy Bícha <jbicha@ubuntu.com>  Thu, 20 Jun 2024 09:24:41 -0400

=== debian/tests/control ===
--- 
+++ 
@@ -4,3 +4,5 @@
  libtest-command-simple-perl,
  perl,
  xvfb,
+ xauth,
+Restrictions: superficial, allow-stderr

## astroidmail 0.17%2Bds

=== debian/rules ===
#!/usr/bin/make -f

# resolve if release is experimental
include /usr/share/dpkg/pkg-info.mk
EXP_RELEASE = $(filter experimental% UNRELEASED,$(DEB_DISTRIBUTION))

%:
	dh $@

# use virtual X11 and UTF-8 in testsuite
# ignore testuite failure when targeting experimental
override_dh_auto_test:
	LC_ALL=C.UTF-8 xvfb-run -a \
		dh_auto_test --no-parallel $(if $(EXP_RELEASE), || true)
